#include <windows.h>
#include <stdio.h>
#include "main.h"
#include "resource.h"
#include "cpu.h"
#include "tracer.h"
#include "commctrl.h"

int inited=0;
BYTE logging=0;
BYTE insound=0;
BYTE logdata[0x800000]; // bit0=readyet, bit1=writtenyet, bit2=needed
DWORD msgwhere=0;
int framecount=0,withthequickness=0,quickcount=0;
DWORD lastoffset=0;
extern int riptimeoutreset;
extern long AlistCount, riptimeout;

DWORD TLBTransR(DWORD in) {
	//return in&0x1fffffff;
	if (TLB_ReadMap[in>>12] == 0) return 0;
	return (TLB_ReadMap[in>>12]+(BYTE*)in-RDRAM)&0x3fffff;
}

DWORD TLBTransW(DWORD in) {
	if (TLB_WriteMap[in>>12] == 0) return 0;
	return (TLB_WriteMap[in>>12]+(BYTE*)in-RDRAM)&0x3fffff;
}

void tracerLB_VAddr ( DWORD VAddr, BYTE * Value ) {
	if (logging) {
		//VAddr = ((BYTE *)(TLB_ReadMap[VAddr >> 12]) + VAddr) - RDRAM;
		if (!(logdata[TLBTransR(VAddr)]&3)) {
			logdata[TLBTransR(VAddr)]|=4;
			if (riptimeoutreset) AlistCount=0;
		}
		logdata[TLBTransR(VAddr)]|=1;
	}
	return;
}

void tracerLD_VAddr ( DWORD VAddr, unsigned _int64 * Value ) {
	int c;
	if (logging) {
		//VAddr = ((BYTE *)(TLB_ReadMap[VAddr >> 12]) + VAddr) - RDRAM;
		for (c=0; c < 8; c++) {
			if (!(logdata[(TLBTransR(VAddr))+c]&3)) {
				logdata[(TLBTransR(VAddr))+c]|=4;
				if (riptimeoutreset) AlistCount=0;
			}
			logdata[(TLBTransR(VAddr))+c]|=1;
		}
	}
	return;
}

void tracerLH_VAddr ( DWORD VAddr, WORD * Value ) {
	int c;
	if (logging) {
		//VAddr = ((BYTE *)(TLB_ReadMap[VAddr >> 12]) + VAddr) - RDRAM;
		for (c=0; c < 2; c++) {
			if (!(logdata[(TLBTransR(VAddr))+c]&3)) {
				logdata[(TLBTransR(VAddr))+c]|=4;
				if (riptimeoutreset) AlistCount=0;
			}
			logdata[(TLBTransR(VAddr))+c]|=1;
		}
	}
	return;
}

void tracerLW_VAddr ( DWORD VAddr, DWORD * Value ) {
	static DWORD lastpc;
	int c;

	//if (PROGRAM_COUNTER == 0x80134990) DisplayError("yeah!");
	
	//lastpc=PROGRAM_COUNTER;

	//if (PROGRAM_COUNTER == 0x80236e28) {
	//	DisplayError("reading %08x\na0=%08x",VAddr,GPR[4].UW[0]);
	//}

	// Auto-save at this point (just before SM64 specifies a song)
	// Auto-save at this point (just before PW64 specifies a song)
	if (createsparse && !logging && VAddr == TraceBeginOffset && PROGRAM_COUNTER == VAddr) {
		//RDRAM[0x30fe57^3]=0x1e;

		//DisplayError("Beginning Trace");

		Machine_SaveState();
		inittracer();

		//inittracer();
		//withthequickness=1;
		//quickcount=0;
	}

	//if (VAddr == 0x802963a0 && PROGRAM_COUNTER == VAddr) {
	//	DisplayError("Source of AudioInit\nra=%08x",GPR[31].UW[0]);
	//}
	
	if (logging) {
		//VAddr = ((BYTE *)(TLB_ReadMap[VAddr >> 12]) + VAddr) - RDRAM;
		for (c=0; c < 4; c++) {
			if (!(logdata[(TLBTransR(VAddr))+c]&3)) {
				logdata[(TLBTransR(VAddr))+c]|=4;
				if (riptimeoutreset) AlistCount=0;
			}
			logdata[(TLBTransR(VAddr))+c]|=1;
		}
	}
	//if (logging&&(VAddr&0x10000000)) {
	//	DisplayError("Read from ROM");
	//}
	return;
}

void tracerSB_VAddr ( DWORD VAddr, BYTE Value ) {
	if (logging) {
		//VAddr = ((BYTE *)(TLB_WriteMap[VAddr >> 12]) + VAddr) - RDRAM;
		logdata[TLBTransW(VAddr)]|=2;
	}
	return;
}

void tracerSD_VAddr ( DWORD VAddr, unsigned _int64 Value ) {
	int c;
	if (logging) {
		//VAddr = ((BYTE *)(TLB_WriteMap[VAddr >> 12]) + VAddr) - RDRAM;
		for (c=0; logging && c < 8; c++) {
			logdata[(TLBTransW(VAddr))+c]|=2;
		}
	}
	return;
}

void tracerSH_VAddr ( DWORD VAddr, WORD Value ) {
	int c;
	if (logging) {
		//VAddr = ((BYTE *)(TLB_WriteMap[VAddr >> 12]) + VAddr) - RDRAM;
		for (c=0; logging && c < 2; c++) {
			logdata[(TLBTransW(VAddr))+c]|=2;
		}
	}
	return;
}

void tracerSW_VAddr ( DWORD VAddr, DWORD Value ) {
	int c;
	if (logging) {
		//VAddr = ((BYTE *)(TLB_WriteMap[VAddr >> 12]) + VAddr) - RDRAM;
		for (c=0; logging && c < 4; c++) {
			logdata[(TLBTransW(VAddr))+c]|=2;
		}
	}
	return;
}

void WriteSparseRom (char *SparseRomFilename, char *CleanSaveFileName, char *pilogFilename) 
{
	DWORD count, runstart, len;
	FILE * outfile;
	BYTE run;

	Machine_CleanSave(CleanSaveFileName);

	// Create sparse ROM
	if (piisread && createsparse) {
		pilogfile=fopen(pilogFilename,"wt");
		outfile=fopen(SparseRomFilename,"wb");
	
		fprintf(outfile,"SR64"); // SparseRom64
		run=0;
		//len=0x800000;
		//runstart=0;
		//fwrite(&len,1,4,outfile);
		//fwrite(&runstart,1,4,outfile);
		//fwrite(ROM,1,len,outfile);
		
		for (count=0; count < 0x800000; count++) {
			if (piisread[count] && !run) {
				fprintf(pilogfile,"%08x-",count*8); runstart=count;
			}
			if (!piisread[count] && run) {
				fprintf(pilogfile,"%08x\n",(count-1)*8);
				len = (count-runstart)*8;
				/*if (logging && runstart == 0x200) { // entry point (right after boot)
					// We assume that the segment right after the boot code is
					// loaded into RAM at entrypoint.
					DWORD entrypoint=(((DWORD*)ROM)[2]&0x3fffffff)/8,i;
					// do zeroing of unused data
					for (i=0; i < 0x100000; i++) { // normal size of code block
						if (!logdata[entrypoint+i]&4) {
							ROM[0x1000+i]=0;
						}
					}
				}*/
				fwrite(&len,1,4,outfile); // chunk length
				runstart*=8;
				fwrite(&runstart,1,4,outfile); // offset of chunk (in ROM)
				runstart/=8;
				fwrite(ROM+runstart*8,1,(count-runstart)*8,outfile); // chunk
			}
			run = piisread[count];
		}
		
		len = 0;
		fwrite(&len,4,1,outfile); // terminating zero length chunk
		fclose(pilogfile);
		fclose(outfile);
	}
	if (piisread) {free(piisread); piisread=0;}
	closetracer();
}

void inittracer(void) {
	DWORD c;
	//saddr=startaddr;
	//eaddr=endaddr;
	//logging=0;
	//framecount=0;
	//if (!logfile) logfile = fopen("c:\\windows\\desktop\\log.txt","wt");
	//if (!inited) {
	logging=1;
		for (c=0; c < 0x800000; c++) logdata[c]=0;

		lastoffset=0;
	//}
	CheckMenuItem(hMainMenu,ID_LOGGING_ENABLED,MF_BYCOMMAND | MFS_CHECKED);
	withthequickness=0;
	//inited=1;
}

void closetracer(void) {
	//DWORD c;
	/*
	DWORD rcount=0,ccount=0;
	for (c=0; c < 0x80000; c++) {
		if (changeable[c]) {
			ccount++;
			fprintf(logfile,"%08x: %02x\n",c*8,changecount[c]);
		}
		if (readyet[c]) rcount++;
	}
	fprintf (logfile,"Read: %08x\nChanged: %08x\n",rcount,ccount);
	*/
	//if (logfile) fclose(logfile);
	//logfile=0;
	
	logging=0;
	CheckMenuItem(hMainMenu,ID_LOGGING_ENABLED,MF_BYCOMMAND | MFS_UNCHECKED);
	inited=0;
}